// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_graph_msgs:msg/Graph.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/msg/graph.hpp"


#ifndef TUW_GRAPH_MSGS__MSG__DETAIL__GRAPH__STRUCT_HPP_
#define TUW_GRAPH_MSGS__MSG__DETAIL__GRAPH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'origin'
#include "geometry_msgs/msg/detail/pose__struct.hpp"
// Member 'nodes'
#include "tuw_graph_msgs/msg/detail/node__struct.hpp"
// Member 'edges'
#include "tuw_graph_msgs/msg/detail/edge__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_graph_msgs__msg__Graph __attribute__((deprecated))
#else
# define DEPRECATED__tuw_graph_msgs__msg__Graph __declspec(deprecated)
#endif

namespace tuw_graph_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Graph_
{
  using Type = Graph_<ContainerAllocator>;

  explicit Graph_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    origin(_init)
  {
    (void)_init;
  }

  explicit Graph_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    origin(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _origin_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _origin_type origin;
  using _nodes_type =
    std::vector<tuw_graph_msgs::msg::Node_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_graph_msgs::msg::Node_<ContainerAllocator>>>;
  _nodes_type nodes;
  using _edges_type =
    std::vector<tuw_graph_msgs::msg::Edge_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_graph_msgs::msg::Edge_<ContainerAllocator>>>;
  _edges_type edges;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__origin(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->origin = _arg;
    return *this;
  }
  Type & set__nodes(
    const std::vector<tuw_graph_msgs::msg::Node_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_graph_msgs::msg::Node_<ContainerAllocator>>> & _arg)
  {
    this->nodes = _arg;
    return *this;
  }
  Type & set__edges(
    const std::vector<tuw_graph_msgs::msg::Edge_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_graph_msgs::msg::Edge_<ContainerAllocator>>> & _arg)
  {
    this->edges = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_graph_msgs::msg::Graph_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_graph_msgs::msg::Graph_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_graph_msgs::msg::Graph_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_graph_msgs::msg::Graph_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_graph_msgs::msg::Graph_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_graph_msgs::msg::Graph_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_graph_msgs::msg::Graph_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_graph_msgs::msg::Graph_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_graph_msgs::msg::Graph_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_graph_msgs::msg::Graph_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_graph_msgs__msg__Graph
    std::shared_ptr<tuw_graph_msgs::msg::Graph_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_graph_msgs__msg__Graph
    std::shared_ptr<tuw_graph_msgs::msg::Graph_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Graph_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->origin != other.origin) {
      return false;
    }
    if (this->nodes != other.nodes) {
      return false;
    }
    if (this->edges != other.edges) {
      return false;
    }
    return true;
  }
  bool operator!=(const Graph_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Graph_

// alias to use template instance with default allocator
using Graph =
  tuw_graph_msgs::msg::Graph_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_graph_msgs

#endif  // TUW_GRAPH_MSGS__MSG__DETAIL__GRAPH__STRUCT_HPP_
