// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_graph_msgs:msg/Node.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/msg/node.h"


#ifndef TUW_GRAPH_MSGS__MSG__DETAIL__NODE__STRUCT_H_
#define TUW_GRAPH_MSGS__MSG__DETAIL__NODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'FLAG_NA'.
enum
{
  tuw_graph_msgs__msg__Node__FLAG_NA = 0ul
};

/// Constant 'FLAG_UNTOUCHED'.
enum
{
  tuw_graph_msgs__msg__Node__FLAG_UNTOUCHED = 1ul
};

/// Constant 'FLAG_OPEN'.
enum
{
  tuw_graph_msgs__msg__Node__FLAG_OPEN = 2ul
};

/// Constant 'FLAG_CLOSED'.
enum
{
  tuw_graph_msgs__msg__Node__FLAG_CLOSED = 3ul
};

/// Constant 'FLAG_VISITED'.
enum
{
  tuw_graph_msgs__msg__Node__FLAG_VISITED = 4ul
};

/// Constant 'FLAG_START'.
enum
{
  tuw_graph_msgs__msg__Node__FLAG_START = 5ul
};

/// Constant 'FLAG_GOAL'.
enum
{
  tuw_graph_msgs__msg__Node__FLAG_GOAL = 6ul
};

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'flags'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/Node in the package tuw_graph_msgs.
/**
  * A single node in a graph
  * Each node of the same graph must have a unique id.
 */
typedef struct tuw_graph_msgs__msg__Node
{
  /// Node id
  int64_t id;
  /// True if it can be used for planning
  bool valid;
  /// Position
  geometry_msgs__msg__Pose pose;
  /// Flags or attributes
  rosidl_runtime_c__uint32__Sequence flags;
} tuw_graph_msgs__msg__Node;

// Struct for a sequence of tuw_graph_msgs__msg__Node.
typedef struct tuw_graph_msgs__msg__Node__Sequence
{
  tuw_graph_msgs__msg__Node * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_graph_msgs__msg__Node__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_GRAPH_MSGS__MSG__DETAIL__NODE__STRUCT_H_
