// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_graph_msgs:msg/Node.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/msg/node.hpp"


#ifndef TUW_GRAPH_MSGS__MSG__DETAIL__NODE__TRAITS_HPP_
#define TUW_GRAPH_MSGS__MSG__DETAIL__NODE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_graph_msgs/msg/detail/node__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace tuw_graph_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Node & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: valid
  {
    out << "valid: ";
    rosidl_generator_traits::value_to_yaml(msg.valid, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: flags
  {
    if (msg.flags.size() == 0) {
      out << "flags: []";
    } else {
      out << "flags: [";
      size_t pending_items = msg.flags.size();
      for (auto item : msg.flags) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Node & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: valid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "valid: ";
    rosidl_generator_traits::value_to_yaml(msg.valid, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.flags.size() == 0) {
      out << "flags: []\n";
    } else {
      out << "flags:\n";
      for (auto item : msg.flags) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Node & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_graph_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_graph_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_graph_msgs::msg::Node & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_graph_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_graph_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_graph_msgs::msg::Node & msg)
{
  return tuw_graph_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_graph_msgs::msg::Node>()
{
  return "tuw_graph_msgs::msg::Node";
}

template<>
inline const char * name<tuw_graph_msgs::msg::Node>()
{
  return "tuw_graph_msgs/msg/Node";
}

template<>
struct has_fixed_size<tuw_graph_msgs::msg::Node>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_graph_msgs::msg::Node>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_graph_msgs::msg::Node>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_GRAPH_MSGS__MSG__DETAIL__NODE__TRAITS_HPP_
