// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_graph_msgs:msg/State.idl
// generated code does not contain a copyright notice
#include "tuw_graph_msgs/msg/detail/state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `list_node_open`
// Member `list_edge_open`
// Member `list_node_closed`
// Member `list_edge_closed`
#include "rosidl_runtime_c/primitives_sequence_functions.h"
// Member `color_open`
// Member `color_closed`
#include "std_msgs/msg/detail/color_rgba__functions.h"

bool
tuw_graph_msgs__msg__State__init(tuw_graph_msgs__msg__State * msg)
{
  if (!msg) {
    return false;
  }
  // step
  // list_node_open
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->list_node_open, 0)) {
    tuw_graph_msgs__msg__State__fini(msg);
    return false;
  }
  // list_edge_open
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->list_edge_open, 0)) {
    tuw_graph_msgs__msg__State__fini(msg);
    return false;
  }
  // color_open
  if (!std_msgs__msg__ColorRGBA__Sequence__init(&msg->color_open, 0)) {
    tuw_graph_msgs__msg__State__fini(msg);
    return false;
  }
  // list_node_closed
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->list_node_closed, 0)) {
    tuw_graph_msgs__msg__State__fini(msg);
    return false;
  }
  // list_edge_closed
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->list_edge_closed, 0)) {
    tuw_graph_msgs__msg__State__fini(msg);
    return false;
  }
  // color_closed
  if (!std_msgs__msg__ColorRGBA__Sequence__init(&msg->color_closed, 0)) {
    tuw_graph_msgs__msg__State__fini(msg);
    return false;
  }
  return true;
}

void
tuw_graph_msgs__msg__State__fini(tuw_graph_msgs__msg__State * msg)
{
  if (!msg) {
    return;
  }
  // step
  // list_node_open
  rosidl_runtime_c__int32__Sequence__fini(&msg->list_node_open);
  // list_edge_open
  rosidl_runtime_c__int32__Sequence__fini(&msg->list_edge_open);
  // color_open
  std_msgs__msg__ColorRGBA__Sequence__fini(&msg->color_open);
  // list_node_closed
  rosidl_runtime_c__int32__Sequence__fini(&msg->list_node_closed);
  // list_edge_closed
  rosidl_runtime_c__int32__Sequence__fini(&msg->list_edge_closed);
  // color_closed
  std_msgs__msg__ColorRGBA__Sequence__fini(&msg->color_closed);
}

bool
tuw_graph_msgs__msg__State__are_equal(const tuw_graph_msgs__msg__State * lhs, const tuw_graph_msgs__msg__State * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // step
  if (lhs->step != rhs->step) {
    return false;
  }
  // list_node_open
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->list_node_open), &(rhs->list_node_open)))
  {
    return false;
  }
  // list_edge_open
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->list_edge_open), &(rhs->list_edge_open)))
  {
    return false;
  }
  // color_open
  if (!std_msgs__msg__ColorRGBA__Sequence__are_equal(
      &(lhs->color_open), &(rhs->color_open)))
  {
    return false;
  }
  // list_node_closed
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->list_node_closed), &(rhs->list_node_closed)))
  {
    return false;
  }
  // list_edge_closed
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->list_edge_closed), &(rhs->list_edge_closed)))
  {
    return false;
  }
  // color_closed
  if (!std_msgs__msg__ColorRGBA__Sequence__are_equal(
      &(lhs->color_closed), &(rhs->color_closed)))
  {
    return false;
  }
  return true;
}

bool
tuw_graph_msgs__msg__State__copy(
  const tuw_graph_msgs__msg__State * input,
  tuw_graph_msgs__msg__State * output)
{
  if (!input || !output) {
    return false;
  }
  // step
  output->step = input->step;
  // list_node_open
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->list_node_open), &(output->list_node_open)))
  {
    return false;
  }
  // list_edge_open
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->list_edge_open), &(output->list_edge_open)))
  {
    return false;
  }
  // color_open
  if (!std_msgs__msg__ColorRGBA__Sequence__copy(
      &(input->color_open), &(output->color_open)))
  {
    return false;
  }
  // list_node_closed
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->list_node_closed), &(output->list_node_closed)))
  {
    return false;
  }
  // list_edge_closed
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->list_edge_closed), &(output->list_edge_closed)))
  {
    return false;
  }
  // color_closed
  if (!std_msgs__msg__ColorRGBA__Sequence__copy(
      &(input->color_closed), &(output->color_closed)))
  {
    return false;
  }
  return true;
}

tuw_graph_msgs__msg__State *
tuw_graph_msgs__msg__State__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__msg__State * msg = (tuw_graph_msgs__msg__State *)allocator.allocate(sizeof(tuw_graph_msgs__msg__State), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_graph_msgs__msg__State));
  bool success = tuw_graph_msgs__msg__State__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_graph_msgs__msg__State__destroy(tuw_graph_msgs__msg__State * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_graph_msgs__msg__State__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_graph_msgs__msg__State__Sequence__init(tuw_graph_msgs__msg__State__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__msg__State * data = NULL;

  if (size) {
    data = (tuw_graph_msgs__msg__State *)allocator.zero_allocate(size, sizeof(tuw_graph_msgs__msg__State), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_graph_msgs__msg__State__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_graph_msgs__msg__State__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_graph_msgs__msg__State__Sequence__fini(tuw_graph_msgs__msg__State__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_graph_msgs__msg__State__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_graph_msgs__msg__State__Sequence *
tuw_graph_msgs__msg__State__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__msg__State__Sequence * array = (tuw_graph_msgs__msg__State__Sequence *)allocator.allocate(sizeof(tuw_graph_msgs__msg__State__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_graph_msgs__msg__State__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_graph_msgs__msg__State__Sequence__destroy(tuw_graph_msgs__msg__State__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_graph_msgs__msg__State__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_graph_msgs__msg__State__Sequence__are_equal(const tuw_graph_msgs__msg__State__Sequence * lhs, const tuw_graph_msgs__msg__State__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_graph_msgs__msg__State__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_graph_msgs__msg__State__Sequence__copy(
  const tuw_graph_msgs__msg__State__Sequence * input,
  tuw_graph_msgs__msg__State__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_graph_msgs__msg__State);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_graph_msgs__msg__State * data =
      (tuw_graph_msgs__msg__State *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_graph_msgs__msg__State__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_graph_msgs__msg__State__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_graph_msgs__msg__State__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
