// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_graph_msgs:msg/State.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/msg/state.hpp"


#ifndef TUW_GRAPH_MSGS__MSG__DETAIL__STATE__STRUCT_HPP_
#define TUW_GRAPH_MSGS__MSG__DETAIL__STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'color_open'
// Member 'color_closed'
#include "std_msgs/msg/detail/color_rgba__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_graph_msgs__msg__State __attribute__((deprecated))
#else
# define DEPRECATED__tuw_graph_msgs__msg__State __declspec(deprecated)
#endif

namespace tuw_graph_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct State_
{
  using Type = State_<ContainerAllocator>;

  explicit State_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->step = 0ll;
    }
  }

  explicit State_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->step = 0ll;
    }
  }

  // field types and members
  using _step_type =
    int64_t;
  _step_type step;
  using _list_node_open_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _list_node_open_type list_node_open;
  using _list_edge_open_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _list_edge_open_type list_edge_open;
  using _color_open_type =
    std::vector<std_msgs::msg::ColorRGBA_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std_msgs::msg::ColorRGBA_<ContainerAllocator>>>;
  _color_open_type color_open;
  using _list_node_closed_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _list_node_closed_type list_node_closed;
  using _list_edge_closed_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _list_edge_closed_type list_edge_closed;
  using _color_closed_type =
    std::vector<std_msgs::msg::ColorRGBA_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std_msgs::msg::ColorRGBA_<ContainerAllocator>>>;
  _color_closed_type color_closed;

  // setters for named parameter idiom
  Type & set__step(
    const int64_t & _arg)
  {
    this->step = _arg;
    return *this;
  }
  Type & set__list_node_open(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->list_node_open = _arg;
    return *this;
  }
  Type & set__list_edge_open(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->list_edge_open = _arg;
    return *this;
  }
  Type & set__color_open(
    const std::vector<std_msgs::msg::ColorRGBA_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std_msgs::msg::ColorRGBA_<ContainerAllocator>>> & _arg)
  {
    this->color_open = _arg;
    return *this;
  }
  Type & set__list_node_closed(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->list_node_closed = _arg;
    return *this;
  }
  Type & set__list_edge_closed(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->list_edge_closed = _arg;
    return *this;
  }
  Type & set__color_closed(
    const std::vector<std_msgs::msg::ColorRGBA_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std_msgs::msg::ColorRGBA_<ContainerAllocator>>> & _arg)
  {
    this->color_closed = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_graph_msgs::msg::State_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_graph_msgs::msg::State_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_graph_msgs::msg::State_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_graph_msgs::msg::State_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_graph_msgs::msg::State_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_graph_msgs::msg::State_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_graph_msgs::msg::State_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_graph_msgs::msg::State_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_graph_msgs::msg::State_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_graph_msgs::msg::State_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_graph_msgs__msg__State
    std::shared_ptr<tuw_graph_msgs::msg::State_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_graph_msgs__msg__State
    std::shared_ptr<tuw_graph_msgs::msg::State_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const State_ & other) const
  {
    if (this->step != other.step) {
      return false;
    }
    if (this->list_node_open != other.list_node_open) {
      return false;
    }
    if (this->list_edge_open != other.list_edge_open) {
      return false;
    }
    if (this->color_open != other.color_open) {
      return false;
    }
    if (this->list_node_closed != other.list_node_closed) {
      return false;
    }
    if (this->list_edge_closed != other.list_edge_closed) {
      return false;
    }
    if (this->color_closed != other.color_closed) {
      return false;
    }
    return true;
  }
  bool operator!=(const State_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct State_

// alias to use template instance with default allocator
using State =
  tuw_graph_msgs::msg::State_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_graph_msgs

#endif  // TUW_GRAPH_MSGS__MSG__DETAIL__STATE__STRUCT_HPP_
