// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_graph_msgs:srv/GetGraph.idl
// generated code does not contain a copyright notice
#include "tuw_graph_msgs/srv/detail/get_graph__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
tuw_graph_msgs__srv__GetGraph_Request__init(tuw_graph_msgs__srv__GetGraph_Request * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
tuw_graph_msgs__srv__GetGraph_Request__fini(tuw_graph_msgs__srv__GetGraph_Request * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
tuw_graph_msgs__srv__GetGraph_Request__are_equal(const tuw_graph_msgs__srv__GetGraph_Request * lhs, const tuw_graph_msgs__srv__GetGraph_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
tuw_graph_msgs__srv__GetGraph_Request__copy(
  const tuw_graph_msgs__srv__GetGraph_Request * input,
  tuw_graph_msgs__srv__GetGraph_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

tuw_graph_msgs__srv__GetGraph_Request *
tuw_graph_msgs__srv__GetGraph_Request__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__srv__GetGraph_Request * msg = (tuw_graph_msgs__srv__GetGraph_Request *)allocator.allocate(sizeof(tuw_graph_msgs__srv__GetGraph_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_graph_msgs__srv__GetGraph_Request));
  bool success = tuw_graph_msgs__srv__GetGraph_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_graph_msgs__srv__GetGraph_Request__destroy(tuw_graph_msgs__srv__GetGraph_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_graph_msgs__srv__GetGraph_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_graph_msgs__srv__GetGraph_Request__Sequence__init(tuw_graph_msgs__srv__GetGraph_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__srv__GetGraph_Request * data = NULL;

  if (size) {
    data = (tuw_graph_msgs__srv__GetGraph_Request *)allocator.zero_allocate(size, sizeof(tuw_graph_msgs__srv__GetGraph_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_graph_msgs__srv__GetGraph_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_graph_msgs__srv__GetGraph_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_graph_msgs__srv__GetGraph_Request__Sequence__fini(tuw_graph_msgs__srv__GetGraph_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_graph_msgs__srv__GetGraph_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_graph_msgs__srv__GetGraph_Request__Sequence *
tuw_graph_msgs__srv__GetGraph_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__srv__GetGraph_Request__Sequence * array = (tuw_graph_msgs__srv__GetGraph_Request__Sequence *)allocator.allocate(sizeof(tuw_graph_msgs__srv__GetGraph_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_graph_msgs__srv__GetGraph_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_graph_msgs__srv__GetGraph_Request__Sequence__destroy(tuw_graph_msgs__srv__GetGraph_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_graph_msgs__srv__GetGraph_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_graph_msgs__srv__GetGraph_Request__Sequence__are_equal(const tuw_graph_msgs__srv__GetGraph_Request__Sequence * lhs, const tuw_graph_msgs__srv__GetGraph_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_graph_msgs__srv__GetGraph_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_graph_msgs__srv__GetGraph_Request__Sequence__copy(
  const tuw_graph_msgs__srv__GetGraph_Request__Sequence * input,
  tuw_graph_msgs__srv__GetGraph_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_graph_msgs__srv__GetGraph_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_graph_msgs__srv__GetGraph_Request * data =
      (tuw_graph_msgs__srv__GetGraph_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_graph_msgs__srv__GetGraph_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_graph_msgs__srv__GetGraph_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_graph_msgs__srv__GetGraph_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `graph`
#include "tuw_graph_msgs/msg/detail/graph__functions.h"

bool
tuw_graph_msgs__srv__GetGraph_Response__init(tuw_graph_msgs__srv__GetGraph_Response * msg)
{
  if (!msg) {
    return false;
  }
  // graph
  if (!tuw_graph_msgs__msg__Graph__init(&msg->graph)) {
    tuw_graph_msgs__srv__GetGraph_Response__fini(msg);
    return false;
  }
  return true;
}

void
tuw_graph_msgs__srv__GetGraph_Response__fini(tuw_graph_msgs__srv__GetGraph_Response * msg)
{
  if (!msg) {
    return;
  }
  // graph
  tuw_graph_msgs__msg__Graph__fini(&msg->graph);
}

bool
tuw_graph_msgs__srv__GetGraph_Response__are_equal(const tuw_graph_msgs__srv__GetGraph_Response * lhs, const tuw_graph_msgs__srv__GetGraph_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // graph
  if (!tuw_graph_msgs__msg__Graph__are_equal(
      &(lhs->graph), &(rhs->graph)))
  {
    return false;
  }
  return true;
}

bool
tuw_graph_msgs__srv__GetGraph_Response__copy(
  const tuw_graph_msgs__srv__GetGraph_Response * input,
  tuw_graph_msgs__srv__GetGraph_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // graph
  if (!tuw_graph_msgs__msg__Graph__copy(
      &(input->graph), &(output->graph)))
  {
    return false;
  }
  return true;
}

tuw_graph_msgs__srv__GetGraph_Response *
tuw_graph_msgs__srv__GetGraph_Response__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__srv__GetGraph_Response * msg = (tuw_graph_msgs__srv__GetGraph_Response *)allocator.allocate(sizeof(tuw_graph_msgs__srv__GetGraph_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_graph_msgs__srv__GetGraph_Response));
  bool success = tuw_graph_msgs__srv__GetGraph_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_graph_msgs__srv__GetGraph_Response__destroy(tuw_graph_msgs__srv__GetGraph_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_graph_msgs__srv__GetGraph_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_graph_msgs__srv__GetGraph_Response__Sequence__init(tuw_graph_msgs__srv__GetGraph_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__srv__GetGraph_Response * data = NULL;

  if (size) {
    data = (tuw_graph_msgs__srv__GetGraph_Response *)allocator.zero_allocate(size, sizeof(tuw_graph_msgs__srv__GetGraph_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_graph_msgs__srv__GetGraph_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_graph_msgs__srv__GetGraph_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_graph_msgs__srv__GetGraph_Response__Sequence__fini(tuw_graph_msgs__srv__GetGraph_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_graph_msgs__srv__GetGraph_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_graph_msgs__srv__GetGraph_Response__Sequence *
tuw_graph_msgs__srv__GetGraph_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__srv__GetGraph_Response__Sequence * array = (tuw_graph_msgs__srv__GetGraph_Response__Sequence *)allocator.allocate(sizeof(tuw_graph_msgs__srv__GetGraph_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_graph_msgs__srv__GetGraph_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_graph_msgs__srv__GetGraph_Response__Sequence__destroy(tuw_graph_msgs__srv__GetGraph_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_graph_msgs__srv__GetGraph_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_graph_msgs__srv__GetGraph_Response__Sequence__are_equal(const tuw_graph_msgs__srv__GetGraph_Response__Sequence * lhs, const tuw_graph_msgs__srv__GetGraph_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_graph_msgs__srv__GetGraph_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_graph_msgs__srv__GetGraph_Response__Sequence__copy(
  const tuw_graph_msgs__srv__GetGraph_Response__Sequence * input,
  tuw_graph_msgs__srv__GetGraph_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_graph_msgs__srv__GetGraph_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_graph_msgs__srv__GetGraph_Response * data =
      (tuw_graph_msgs__srv__GetGraph_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_graph_msgs__srv__GetGraph_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_graph_msgs__srv__GetGraph_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_graph_msgs__srv__GetGraph_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "tuw_graph_msgs/srv/detail/get_graph__functions.h"

bool
tuw_graph_msgs__srv__GetGraph_Event__init(tuw_graph_msgs__srv__GetGraph_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    tuw_graph_msgs__srv__GetGraph_Event__fini(msg);
    return false;
  }
  // request
  if (!tuw_graph_msgs__srv__GetGraph_Request__Sequence__init(&msg->request, 0)) {
    tuw_graph_msgs__srv__GetGraph_Event__fini(msg);
    return false;
  }
  // response
  if (!tuw_graph_msgs__srv__GetGraph_Response__Sequence__init(&msg->response, 0)) {
    tuw_graph_msgs__srv__GetGraph_Event__fini(msg);
    return false;
  }
  return true;
}

void
tuw_graph_msgs__srv__GetGraph_Event__fini(tuw_graph_msgs__srv__GetGraph_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  tuw_graph_msgs__srv__GetGraph_Request__Sequence__fini(&msg->request);
  // response
  tuw_graph_msgs__srv__GetGraph_Response__Sequence__fini(&msg->response);
}

bool
tuw_graph_msgs__srv__GetGraph_Event__are_equal(const tuw_graph_msgs__srv__GetGraph_Event * lhs, const tuw_graph_msgs__srv__GetGraph_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!tuw_graph_msgs__srv__GetGraph_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!tuw_graph_msgs__srv__GetGraph_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
tuw_graph_msgs__srv__GetGraph_Event__copy(
  const tuw_graph_msgs__srv__GetGraph_Event * input,
  tuw_graph_msgs__srv__GetGraph_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!tuw_graph_msgs__srv__GetGraph_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!tuw_graph_msgs__srv__GetGraph_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

tuw_graph_msgs__srv__GetGraph_Event *
tuw_graph_msgs__srv__GetGraph_Event__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__srv__GetGraph_Event * msg = (tuw_graph_msgs__srv__GetGraph_Event *)allocator.allocate(sizeof(tuw_graph_msgs__srv__GetGraph_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_graph_msgs__srv__GetGraph_Event));
  bool success = tuw_graph_msgs__srv__GetGraph_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_graph_msgs__srv__GetGraph_Event__destroy(tuw_graph_msgs__srv__GetGraph_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_graph_msgs__srv__GetGraph_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_graph_msgs__srv__GetGraph_Event__Sequence__init(tuw_graph_msgs__srv__GetGraph_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__srv__GetGraph_Event * data = NULL;

  if (size) {
    data = (tuw_graph_msgs__srv__GetGraph_Event *)allocator.zero_allocate(size, sizeof(tuw_graph_msgs__srv__GetGraph_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_graph_msgs__srv__GetGraph_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_graph_msgs__srv__GetGraph_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_graph_msgs__srv__GetGraph_Event__Sequence__fini(tuw_graph_msgs__srv__GetGraph_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_graph_msgs__srv__GetGraph_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_graph_msgs__srv__GetGraph_Event__Sequence *
tuw_graph_msgs__srv__GetGraph_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__srv__GetGraph_Event__Sequence * array = (tuw_graph_msgs__srv__GetGraph_Event__Sequence *)allocator.allocate(sizeof(tuw_graph_msgs__srv__GetGraph_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_graph_msgs__srv__GetGraph_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_graph_msgs__srv__GetGraph_Event__Sequence__destroy(tuw_graph_msgs__srv__GetGraph_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_graph_msgs__srv__GetGraph_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_graph_msgs__srv__GetGraph_Event__Sequence__are_equal(const tuw_graph_msgs__srv__GetGraph_Event__Sequence * lhs, const tuw_graph_msgs__srv__GetGraph_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_graph_msgs__srv__GetGraph_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_graph_msgs__srv__GetGraph_Event__Sequence__copy(
  const tuw_graph_msgs__srv__GetGraph_Event__Sequence * input,
  tuw_graph_msgs__srv__GetGraph_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_graph_msgs__srv__GetGraph_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_graph_msgs__srv__GetGraph_Event * data =
      (tuw_graph_msgs__srv__GetGraph_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_graph_msgs__srv__GetGraph_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_graph_msgs__srv__GetGraph_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_graph_msgs__srv__GetGraph_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
