// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_graph_msgs:srv/GetGraph.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/srv/get_graph.h"


#ifndef TUW_GRAPH_MSGS__SRV__DETAIL__GET_GRAPH__STRUCT_H_
#define TUW_GRAPH_MSGS__SRV__DETAIL__GET_GRAPH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/GetGraph in the package tuw_graph_msgs.
typedef struct tuw_graph_msgs__srv__GetGraph_Request
{
  uint8_t structure_needs_at_least_one_member;
} tuw_graph_msgs__srv__GetGraph_Request;

// Struct for a sequence of tuw_graph_msgs__srv__GetGraph_Request.
typedef struct tuw_graph_msgs__srv__GetGraph_Request__Sequence
{
  tuw_graph_msgs__srv__GetGraph_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_graph_msgs__srv__GetGraph_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'graph'
#include "tuw_graph_msgs/msg/detail/graph__struct.h"

/// Struct defined in srv/GetGraph in the package tuw_graph_msgs.
typedef struct tuw_graph_msgs__srv__GetGraph_Response
{
  tuw_graph_msgs__msg__Graph graph;
} tuw_graph_msgs__srv__GetGraph_Response;

// Struct for a sequence of tuw_graph_msgs__srv__GetGraph_Response.
typedef struct tuw_graph_msgs__srv__GetGraph_Response__Sequence
{
  tuw_graph_msgs__srv__GetGraph_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_graph_msgs__srv__GetGraph_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  tuw_graph_msgs__srv__GetGraph_Event__request__MAX_SIZE = 1
};
// response
enum
{
  tuw_graph_msgs__srv__GetGraph_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/GetGraph in the package tuw_graph_msgs.
typedef struct tuw_graph_msgs__srv__GetGraph_Event
{
  service_msgs__msg__ServiceEventInfo info;
  tuw_graph_msgs__srv__GetGraph_Request__Sequence request;
  tuw_graph_msgs__srv__GetGraph_Response__Sequence response;
} tuw_graph_msgs__srv__GetGraph_Event;

// Struct for a sequence of tuw_graph_msgs__srv__GetGraph_Event.
typedef struct tuw_graph_msgs__srv__GetGraph_Event__Sequence
{
  tuw_graph_msgs__srv__GetGraph_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_graph_msgs__srv__GetGraph_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_GRAPH_MSGS__SRV__DETAIL__GET_GRAPH__STRUCT_H_
