// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_graph_msgs:msg/Edge.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/msg/edge.h"


#ifndef TUW_GRAPH_MSGS__MSG__DETAIL__EDGE__STRUCT_H_
#define TUW_GRAPH_MSGS__MSG__DETAIL__EDGE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'FLAG_NA'.
enum
{
  tuw_graph_msgs__msg__Edge__FLAG_NA = 0ul
};

/// Constant 'FLAG_UNTOUCHED'.
enum
{
  tuw_graph_msgs__msg__Edge__FLAG_UNTOUCHED = 1ul
};

/// Constant 'FLAG_OPEN'.
enum
{
  tuw_graph_msgs__msg__Edge__FLAG_OPEN = 2ul
};

/// Constant 'FLAG_CLOSED'.
enum
{
  tuw_graph_msgs__msg__Edge__FLAG_CLOSED = 3ul
};

/// Constant 'FLAG_VISITED'.
enum
{
  tuw_graph_msgs__msg__Edge__FLAG_VISITED = 4ul
};

// Include directives for member types
// Member 'flags'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'path'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in msg/Edge in the package tuw_graph_msgs.
/**
  * A single edge in a graph
  * Each edge of the same graph must have a unique id.
 */
typedef struct tuw_graph_msgs__msg__Edge
{
  /// Edge id
  int64_t id;
  /// True if it can be used for planning
  bool valid;
  /// Weight of the edge
  double weight;
  /// Flags or attributes
  rosidl_runtime_c__uint32__Sequence flags;
  /// Ids start node
  int64_t start;
  /// Ids end node
  int64_t end;
  /// Path between the nodes
  /// - path can be empty
  /// - path does does not include the nodes locations
  geometry_msgs__msg__Pose__Sequence path;
} tuw_graph_msgs__msg__Edge;

// Struct for a sequence of tuw_graph_msgs__msg__Edge.
typedef struct tuw_graph_msgs__msg__Edge__Sequence
{
  tuw_graph_msgs__msg__Edge * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_graph_msgs__msg__Edge__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_GRAPH_MSGS__MSG__DETAIL__EDGE__STRUCT_H_
