// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_graph_msgs:msg/Edge.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/msg/edge.hpp"


#ifndef TUW_GRAPH_MSGS__MSG__DETAIL__EDGE__STRUCT_HPP_
#define TUW_GRAPH_MSGS__MSG__DETAIL__EDGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'path'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_graph_msgs__msg__Edge __attribute__((deprecated))
#else
# define DEPRECATED__tuw_graph_msgs__msg__Edge __declspec(deprecated)
#endif

namespace tuw_graph_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Edge_
{
  using Type = Edge_<ContainerAllocator>;

  explicit Edge_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ll;
      this->valid = false;
      this->weight = 0.0;
      this->start = 0ll;
      this->end = 0ll;
    }
  }

  explicit Edge_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ll;
      this->valid = false;
      this->weight = 0.0;
      this->start = 0ll;
      this->end = 0ll;
    }
  }

  // field types and members
  using _id_type =
    int64_t;
  _id_type id;
  using _valid_type =
    bool;
  _valid_type valid;
  using _weight_type =
    double;
  _weight_type weight;
  using _flags_type =
    std::vector<uint32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint32_t>>;
  _flags_type flags;
  using _start_type =
    int64_t;
  _start_type start;
  using _end_type =
    int64_t;
  _end_type end;
  using _path_type =
    std::vector<geometry_msgs::msg::Pose_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Pose_<ContainerAllocator>>>;
  _path_type path;

  // setters for named parameter idiom
  Type & set__id(
    const int64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__valid(
    const bool & _arg)
  {
    this->valid = _arg;
    return *this;
  }
  Type & set__weight(
    const double & _arg)
  {
    this->weight = _arg;
    return *this;
  }
  Type & set__flags(
    const std::vector<uint32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint32_t>> & _arg)
  {
    this->flags = _arg;
    return *this;
  }
  Type & set__start(
    const int64_t & _arg)
  {
    this->start = _arg;
    return *this;
  }
  Type & set__end(
    const int64_t & _arg)
  {
    this->end = _arg;
    return *this;
  }
  Type & set__path(
    const std::vector<geometry_msgs::msg::Pose_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Pose_<ContainerAllocator>>> & _arg)
  {
    this->path = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint32_t FLAG_NA =
    0u;
  static constexpr uint32_t FLAG_UNTOUCHED =
    1u;
  static constexpr uint32_t FLAG_OPEN =
    2u;
  static constexpr uint32_t FLAG_CLOSED =
    3u;
  static constexpr uint32_t FLAG_VISITED =
    4u;

  // pointer types
  using RawPtr =
    tuw_graph_msgs::msg::Edge_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_graph_msgs::msg::Edge_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_graph_msgs::msg::Edge_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_graph_msgs::msg::Edge_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_graph_msgs::msg::Edge_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_graph_msgs::msg::Edge_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_graph_msgs::msg::Edge_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_graph_msgs::msg::Edge_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_graph_msgs::msg::Edge_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_graph_msgs::msg::Edge_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_graph_msgs__msg__Edge
    std::shared_ptr<tuw_graph_msgs::msg::Edge_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_graph_msgs__msg__Edge
    std::shared_ptr<tuw_graph_msgs::msg::Edge_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Edge_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->valid != other.valid) {
      return false;
    }
    if (this->weight != other.weight) {
      return false;
    }
    if (this->flags != other.flags) {
      return false;
    }
    if (this->start != other.start) {
      return false;
    }
    if (this->end != other.end) {
      return false;
    }
    if (this->path != other.path) {
      return false;
    }
    return true;
  }
  bool operator!=(const Edge_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Edge_

// alias to use template instance with default allocator
using Edge =
  tuw_graph_msgs::msg::Edge_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Edge_<ContainerAllocator>::FLAG_NA;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Edge_<ContainerAllocator>::FLAG_UNTOUCHED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Edge_<ContainerAllocator>::FLAG_OPEN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Edge_<ContainerAllocator>::FLAG_CLOSED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t Edge_<ContainerAllocator>::FLAG_VISITED;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace tuw_graph_msgs

#endif  // TUW_GRAPH_MSGS__MSG__DETAIL__EDGE__STRUCT_HPP_
