// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_graph_msgs:msg/Graph.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/msg/graph.h"


#ifndef TUW_GRAPH_MSGS__MSG__DETAIL__GRAPH__STRUCT_H_
#define TUW_GRAPH_MSGS__MSG__DETAIL__GRAPH__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'origin'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'nodes'
#include "tuw_graph_msgs/msg/detail/node__struct.h"
// Member 'edges'
#include "tuw_graph_msgs/msg/detail/edge__struct.h"

/// Struct defined in msg/Graph in the package tuw_graph_msgs.
/**
  * This message is used to transport a graph between two nodes.
  * Each vertex has a set of points and a width describing the
  * shape of it and additionally successors and predecessors
  * to describe the overall structure of the graph
  *
  * Remark for the TUW_Multi_Robot_Router
  * !! all vertices have to be sorted by id
  * !! every id must be present...
 */
typedef struct tuw_graph_msgs__msg__Graph
{
  /// Header for Timestamp and Id
  std_msgs__msg__Header header;
  /// Graph origin
  geometry_msgs__msg__Pose origin;
  /// The nodes in the graph
  tuw_graph_msgs__msg__Node__Sequence nodes;
  /// The edges in the graph
  tuw_graph_msgs__msg__Edge__Sequence edges;
} tuw_graph_msgs__msg__Graph;

// Struct for a sequence of tuw_graph_msgs__msg__Graph.
typedef struct tuw_graph_msgs__msg__Graph__Sequence
{
  tuw_graph_msgs__msg__Graph * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_graph_msgs__msg__Graph__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_GRAPH_MSGS__MSG__DETAIL__GRAPH__STRUCT_H_
