// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_graph_msgs:msg/Node.idl
// generated code does not contain a copyright notice
#include "tuw_graph_msgs/msg/detail/node__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `flags`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
tuw_graph_msgs__msg__Node__init(tuw_graph_msgs__msg__Node * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // valid
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    tuw_graph_msgs__msg__Node__fini(msg);
    return false;
  }
  // flags
  if (!rosidl_runtime_c__uint32__Sequence__init(&msg->flags, 0)) {
    tuw_graph_msgs__msg__Node__fini(msg);
    return false;
  }
  return true;
}

void
tuw_graph_msgs__msg__Node__fini(tuw_graph_msgs__msg__Node * msg)
{
  if (!msg) {
    return;
  }
  // id
  // valid
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // flags
  rosidl_runtime_c__uint32__Sequence__fini(&msg->flags);
}

bool
tuw_graph_msgs__msg__Node__are_equal(const tuw_graph_msgs__msg__Node * lhs, const tuw_graph_msgs__msg__Node * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // valid
  if (lhs->valid != rhs->valid) {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // flags
  if (!rosidl_runtime_c__uint32__Sequence__are_equal(
      &(lhs->flags), &(rhs->flags)))
  {
    return false;
  }
  return true;
}

bool
tuw_graph_msgs__msg__Node__copy(
  const tuw_graph_msgs__msg__Node * input,
  tuw_graph_msgs__msg__Node * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // valid
  output->valid = input->valid;
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // flags
  if (!rosidl_runtime_c__uint32__Sequence__copy(
      &(input->flags), &(output->flags)))
  {
    return false;
  }
  return true;
}

tuw_graph_msgs__msg__Node *
tuw_graph_msgs__msg__Node__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__msg__Node * msg = (tuw_graph_msgs__msg__Node *)allocator.allocate(sizeof(tuw_graph_msgs__msg__Node), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_graph_msgs__msg__Node));
  bool success = tuw_graph_msgs__msg__Node__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_graph_msgs__msg__Node__destroy(tuw_graph_msgs__msg__Node * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_graph_msgs__msg__Node__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_graph_msgs__msg__Node__Sequence__init(tuw_graph_msgs__msg__Node__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__msg__Node * data = NULL;

  if (size) {
    data = (tuw_graph_msgs__msg__Node *)allocator.zero_allocate(size, sizeof(tuw_graph_msgs__msg__Node), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_graph_msgs__msg__Node__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_graph_msgs__msg__Node__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_graph_msgs__msg__Node__Sequence__fini(tuw_graph_msgs__msg__Node__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_graph_msgs__msg__Node__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_graph_msgs__msg__Node__Sequence *
tuw_graph_msgs__msg__Node__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_graph_msgs__msg__Node__Sequence * array = (tuw_graph_msgs__msg__Node__Sequence *)allocator.allocate(sizeof(tuw_graph_msgs__msg__Node__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_graph_msgs__msg__Node__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_graph_msgs__msg__Node__Sequence__destroy(tuw_graph_msgs__msg__Node__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_graph_msgs__msg__Node__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_graph_msgs__msg__Node__Sequence__are_equal(const tuw_graph_msgs__msg__Node__Sequence * lhs, const tuw_graph_msgs__msg__Node__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_graph_msgs__msg__Node__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_graph_msgs__msg__Node__Sequence__copy(
  const tuw_graph_msgs__msg__Node__Sequence * input,
  tuw_graph_msgs__msg__Node__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_graph_msgs__msg__Node);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_graph_msgs__msg__Node * data =
      (tuw_graph_msgs__msg__Node *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_graph_msgs__msg__Node__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_graph_msgs__msg__Node__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_graph_msgs__msg__Node__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
