// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_graph_msgs:msg/State.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/msg/state.hpp"


#ifndef TUW_GRAPH_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_
#define TUW_GRAPH_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_graph_msgs/msg/detail/state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'color_open'
// Member 'color_closed'
#include "std_msgs/msg/detail/color_rgba__traits.hpp"

namespace tuw_graph_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const State & msg,
  std::ostream & out)
{
  out << "{";
  // member: step
  {
    out << "step: ";
    rosidl_generator_traits::value_to_yaml(msg.step, out);
    out << ", ";
  }

  // member: list_node_open
  {
    if (msg.list_node_open.size() == 0) {
      out << "list_node_open: []";
    } else {
      out << "list_node_open: [";
      size_t pending_items = msg.list_node_open.size();
      for (auto item : msg.list_node_open) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: list_edge_open
  {
    if (msg.list_edge_open.size() == 0) {
      out << "list_edge_open: []";
    } else {
      out << "list_edge_open: [";
      size_t pending_items = msg.list_edge_open.size();
      for (auto item : msg.list_edge_open) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: color_open
  {
    if (msg.color_open.size() == 0) {
      out << "color_open: []";
    } else {
      out << "color_open: [";
      size_t pending_items = msg.color_open.size();
      for (auto item : msg.color_open) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: list_node_closed
  {
    if (msg.list_node_closed.size() == 0) {
      out << "list_node_closed: []";
    } else {
      out << "list_node_closed: [";
      size_t pending_items = msg.list_node_closed.size();
      for (auto item : msg.list_node_closed) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: list_edge_closed
  {
    if (msg.list_edge_closed.size() == 0) {
      out << "list_edge_closed: []";
    } else {
      out << "list_edge_closed: [";
      size_t pending_items = msg.list_edge_closed.size();
      for (auto item : msg.list_edge_closed) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: color_closed
  {
    if (msg.color_closed.size() == 0) {
      out << "color_closed: []";
    } else {
      out << "color_closed: [";
      size_t pending_items = msg.color_closed.size();
      for (auto item : msg.color_closed) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const State & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: step
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "step: ";
    rosidl_generator_traits::value_to_yaml(msg.step, out);
    out << "\n";
  }

  // member: list_node_open
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.list_node_open.size() == 0) {
      out << "list_node_open: []\n";
    } else {
      out << "list_node_open:\n";
      for (auto item : msg.list_node_open) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: list_edge_open
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.list_edge_open.size() == 0) {
      out << "list_edge_open: []\n";
    } else {
      out << "list_edge_open:\n";
      for (auto item : msg.list_edge_open) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: color_open
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.color_open.size() == 0) {
      out << "color_open: []\n";
    } else {
      out << "color_open:\n";
      for (auto item : msg.color_open) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: list_node_closed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.list_node_closed.size() == 0) {
      out << "list_node_closed: []\n";
    } else {
      out << "list_node_closed:\n";
      for (auto item : msg.list_node_closed) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: list_edge_closed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.list_edge_closed.size() == 0) {
      out << "list_edge_closed: []\n";
    } else {
      out << "list_edge_closed:\n";
      for (auto item : msg.list_edge_closed) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: color_closed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.color_closed.size() == 0) {
      out << "color_closed: []\n";
    } else {
      out << "color_closed:\n";
      for (auto item : msg.color_closed) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const State & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_graph_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_graph_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_graph_msgs::msg::State & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_graph_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_graph_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_graph_msgs::msg::State & msg)
{
  return tuw_graph_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_graph_msgs::msg::State>()
{
  return "tuw_graph_msgs::msg::State";
}

template<>
inline const char * name<tuw_graph_msgs::msg::State>()
{
  return "tuw_graph_msgs/msg/State";
}

template<>
struct has_fixed_size<tuw_graph_msgs::msg::State>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_graph_msgs::msg::State>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_graph_msgs::msg::State>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_GRAPH_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_
