// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_graph_msgs:srv/GetGraph.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_graph_msgs/srv/get_graph.hpp"


#ifndef TUW_GRAPH_MSGS__SRV__DETAIL__GET_GRAPH__TRAITS_HPP_
#define TUW_GRAPH_MSGS__SRV__DETAIL__GET_GRAPH__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_graph_msgs/srv/detail/get_graph__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace tuw_graph_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetGraph_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetGraph_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetGraph_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace tuw_graph_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_graph_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_graph_msgs::srv::GetGraph_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_graph_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_graph_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const tuw_graph_msgs::srv::GetGraph_Request & msg)
{
  return tuw_graph_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_graph_msgs::srv::GetGraph_Request>()
{
  return "tuw_graph_msgs::srv::GetGraph_Request";
}

template<>
inline const char * name<tuw_graph_msgs::srv::GetGraph_Request>()
{
  return "tuw_graph_msgs/srv/GetGraph_Request";
}

template<>
struct has_fixed_size<tuw_graph_msgs::srv::GetGraph_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<tuw_graph_msgs::srv::GetGraph_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<tuw_graph_msgs::srv::GetGraph_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'graph'
#include "tuw_graph_msgs/msg/detail/graph__traits.hpp"

namespace tuw_graph_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetGraph_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: graph
  {
    out << "graph: ";
    to_flow_style_yaml(msg.graph, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetGraph_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: graph
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "graph:\n";
    to_block_style_yaml(msg.graph, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetGraph_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace tuw_graph_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_graph_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_graph_msgs::srv::GetGraph_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_graph_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_graph_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const tuw_graph_msgs::srv::GetGraph_Response & msg)
{
  return tuw_graph_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_graph_msgs::srv::GetGraph_Response>()
{
  return "tuw_graph_msgs::srv::GetGraph_Response";
}

template<>
inline const char * name<tuw_graph_msgs::srv::GetGraph_Response>()
{
  return "tuw_graph_msgs/srv/GetGraph_Response";
}

template<>
struct has_fixed_size<tuw_graph_msgs::srv::GetGraph_Response>
  : std::integral_constant<bool, has_fixed_size<tuw_graph_msgs::msg::Graph>::value> {};

template<>
struct has_bounded_size<tuw_graph_msgs::srv::GetGraph_Response>
  : std::integral_constant<bool, has_bounded_size<tuw_graph_msgs::msg::Graph>::value> {};

template<>
struct is_message<tuw_graph_msgs::srv::GetGraph_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace tuw_graph_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetGraph_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetGraph_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetGraph_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace tuw_graph_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_graph_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_graph_msgs::srv::GetGraph_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_graph_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_graph_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const tuw_graph_msgs::srv::GetGraph_Event & msg)
{
  return tuw_graph_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_graph_msgs::srv::GetGraph_Event>()
{
  return "tuw_graph_msgs::srv::GetGraph_Event";
}

template<>
inline const char * name<tuw_graph_msgs::srv::GetGraph_Event>()
{
  return "tuw_graph_msgs/srv/GetGraph_Event";
}

template<>
struct has_fixed_size<tuw_graph_msgs::srv::GetGraph_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_graph_msgs::srv::GetGraph_Event>
  : std::integral_constant<bool, has_bounded_size<service_msgs::msg::ServiceEventInfo>::value && has_bounded_size<tuw_graph_msgs::srv::GetGraph_Request>::value && has_bounded_size<tuw_graph_msgs::srv::GetGraph_Response>::value> {};

template<>
struct is_message<tuw_graph_msgs::srv::GetGraph_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<tuw_graph_msgs::srv::GetGraph>()
{
  return "tuw_graph_msgs::srv::GetGraph";
}

template<>
inline const char * name<tuw_graph_msgs::srv::GetGraph>()
{
  return "tuw_graph_msgs/srv/GetGraph";
}

template<>
struct has_fixed_size<tuw_graph_msgs::srv::GetGraph>
  : std::integral_constant<
    bool,
    has_fixed_size<tuw_graph_msgs::srv::GetGraph_Request>::value &&
    has_fixed_size<tuw_graph_msgs::srv::GetGraph_Response>::value
  >
{
};

template<>
struct has_bounded_size<tuw_graph_msgs::srv::GetGraph>
  : std::integral_constant<
    bool,
    has_bounded_size<tuw_graph_msgs::srv::GetGraph_Request>::value &&
    has_bounded_size<tuw_graph_msgs::srv::GetGraph_Response>::value
  >
{
};

template<>
struct is_service<tuw_graph_msgs::srv::GetGraph>
  : std::true_type
{
};

template<>
struct is_service_request<tuw_graph_msgs::srv::GetGraph_Request>
  : std::true_type
{
};

template<>
struct is_service_response<tuw_graph_msgs::srv::GetGraph_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // TUW_GRAPH_MSGS__SRV__DETAIL__GET_GRAPH__TRAITS_HPP_
